# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetFolderResult',
    'AwaitableGetFolderResult',
    'get_folder',
    'get_folder_output',
]

@pulumi.output_type
class GetFolderResult:
    """
    A collection of values returned by getFolder.
    """
    def __init__(__self__, id=None, name=None, path=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if path and not isinstance(path, str):
            raise TypeError("Expected argument 'path' to be a str")
        pulumi.set(__self__, "path", path)

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def path(self) -> str:
        return pulumi.get(self, "path")


class AwaitableGetFolderResult(GetFolderResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFolderResult(
            id=self.id,
            name=self.name,
            path=self.path)


def get_folder(path: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFolderResult:
    """
    Provides an easy way to retrieve a folder.

    You must specify the absolute path of the folder to retrieve. The content library has "Library"
    folder at the root level. For items in "Personal" folder, the base path is "/Library/Users/user@sumologic.com"
    where "user@sumologic.com" is the email address of the user. For example, if a user with email address
    `wile@acme.com` has `Rockets` folder inside Personal folder, the path of Rockets folder will be
    `/Library/Users/wile@acme.com/Rockets`.

    For items in "Admin Recommended" folder, the base path is "/Library/Admin Recommended". For example,
    given a folder `Acme` in Admin Recommended folder, the path will be `/Library/Admin Recommended/Acme`.

    ## Attributes reference

    The following attributes are exported:

    - `id` - The ID of the folder.
    - `name` - The name of the folder.
    """
    __args__ = dict()
    __args__['path'] = path
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sumologic:index/getFolder:getFolder', __args__, opts=opts, typ=GetFolderResult).value

    return AwaitableGetFolderResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        path=pulumi.get(__ret__, 'path'))


@_utilities.lift_output_func(get_folder)
def get_folder_output(path: Optional[pulumi.Input[str]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetFolderResult]:
    """
    Provides an easy way to retrieve a folder.

    You must specify the absolute path of the folder to retrieve. The content library has "Library"
    folder at the root level. For items in "Personal" folder, the base path is "/Library/Users/user@sumologic.com"
    where "user@sumologic.com" is the email address of the user. For example, if a user with email address
    `wile@acme.com` has `Rockets` folder inside Personal folder, the path of Rockets folder will be
    `/Library/Users/wile@acme.com/Rockets`.

    For items in "Admin Recommended" folder, the base path is "/Library/Admin Recommended". For example,
    given a folder `Acme` in Admin Recommended folder, the path will be `/Library/Admin Recommended/Acme`.

    ## Attributes reference

    The following attributes are exported:

    - `id` - The ID of the folder.
    - `name` - The name of the folder.
    """
    ...
